package de.tfhberlin.panitz.eliza;

/**
  This class contains key/value pairs of how to react
  on certain messages. The data has been taken from the 
  original Eliza implementation in Gofer done by Mark P. Jones.
**/
public class Data {

  private Li l;
  public Data(Li l){this.l = l;init();}

  /**
        respMsgs associates possible answers patterns to certain 
        keywords in the qustion.

        This is a list of pairs. The first element of the pair is a String. 
        The second a list of possible answers for questions 
        containing the first element.
  **/
  public Li /*Pair<<Li<<String>>,Li<<String>>>>*/  respMsgs;   



  public  Li/*Pair<String,String>*/ CONJUGATES ;

    /**
       A list of reactions, when the same question has been repeated.
     **/
  public Li repeatMsgs; 

  private Li nokeyMsgs;
  private Li canYou;
  private Li canI;
  private Li  youAre;
  private Li  iDont;
  private Li  iFeel	;   
  private Li  whyDont ; 
  private Li  whyCant;
  private Li  areYou;
  private Li  iCant;
  private Li  iAm	 ;   
  private Li  you	;     
  private Li  yes;
  private Li  no;
  private Li  computer;
  private Li  problem;
  private Li  iWant;
  private Li  question;
  private Li  name;
  private Li  because;
  private Li  sorry	;
  private Li  dream;
  private Li  hello;
  private Li  maybe;
  private Li  your;
  private Li  always;
  private Li  think;
  private Li  alike;
  private Li  friend;

  private void init(){
   CONJUGATES = 
     l.cons(new Pair("me","you"),
     l.cons(new Pair("are","am"),
     l.cons(new Pair("were","was"),
     l.cons(new Pair("you","I"),
     l.cons(new Pair("your","my"),
     l.cons(new Pair("I've","you've"),
     l.cons(new Pair("I'm","you're"),
     l.cons(new Pair("am","are"),
     l.cons(new Pair("was","were"),
     l.cons(new Pair("I","you"),
     l.cons(new Pair("my","your"),
     l.cons(new Pair("you've","I've"),
     l.cons(new Pair("you're","I'm"),
     l.empty()))))))))))))) ;

  repeatMsgs
    = l.cons( "Why did you repeat yourself?",
      l.cons( "Do you expect a different answer by repeating yourself?",
      l.cons( "Come, come, elucidate your thoughts.",
      l.cons( "Please don't repeat yourself!" ,
      l.empty()))));

  nokeyMsgs
    = l.cons( "I'm not sure I understand you fully.",
      l.cons( "What does that suggest to you?",
      l.cons( "I see.",
      l.cons( "Can you elaborate on that?",
      l.cons( "Say, do you have any psychological problems?" ,
      l.empty())))));


   canYou
     = l.cons( "?Don't you believe that I can",
       l.cons( "?Perhaps you would like to be able to",
       l.cons( "?You want me to be able to" ,
       l.empty())));

   canI
     = l.cons( "?Perhaps you don't want to",
       l.cons("?Do you want to be able to" ,
       l.empty()));


    youAre
     = l.cons( "?What makes you think I am",
       l.cons( "?Does it please you to believe I am",
       l.cons( "?Perhaps you would like to be",
       l.cons( "?Do you sometimes wish you were",
       l.empty()))));

    iDont
     = l.cons( "?Don't you really",
       l.cons( "?Why don't you",
       l.cons( "?Do you wish to be able to",
       l.cons( "Does that trouble you?",
       l.empty()))));

    iFeel	   
     = l.cons( "Tell me more about such feelings.",
       l.cons( "?Do you often feel",
       l.cons( "?Do you enjoy feeling",
       l.empty())));

    whyDont  
     = l.cons( "?Do you really believe I don't",
       l.cons( ".Perhaps in good time I will",
       l.cons( "?Do you want me to",
       l.empty())));

    whyCant
    =  l.cons( "?Do you think you should be able to",
       l.cons( "?Why can't you",
       l.empty()));

    areYou
     = l.cons( "?Why are you interested in whether or not I am",
       l.cons( "?Would you prefer if I were not",
       l.cons( "?Perhaps in your fantasies I am",
       l.empty())));

    iCant
     = l.cons( "?How do you know you can't",
       l.cons( "Have you tried?",
       l.cons( "?Perhaps you can now" ,
       l.empty())));

    iAm	    
     = l.cons( "?Did you come to me because you are",
       l.cons( "?How long have you been",
       l.cons( "?Do you believe it is normal to be",
       l.cons( "?Do you enjoy being" ,
       l.empty()))));

    you	     
     = l.cons( "We were discussing you --not me.",
       l.cons( "?Oh,",
       l.cons( "You're not really talking about me, are you?" ,
       l.empty())));

    yes
     = l.cons( "You seem quite positive.",
       l.cons( "Are you Sure?",
       l.cons( "I see.",
       l.cons( "I understand." ,
       l.empty()))));

    no
     = l.cons( "Are you saying no just to be negative?",
       l.cons( "You are being a bit negative.",
       l.cons( "Why not?",
       l.cons( "Are you sure?",
       l.cons( "Why no?" ,
       l.empty())))));

    computer
     = l.cons( "Do computers worry you?",
       l.cons( "Are you talking about me in particular?",
       l.cons( "Are you frightened by machines?",
       l.cons( "Why do you mention computers?",
       l.cons( "What do you think machines have to do with your problems?",
       l.cons( "Don't you think computers can help people?",
       l.cons( "What is it about machines that worries you?" ,
       l.empty())))))));

    problem
     = l.cons( "Is this really a poblem?",
       l.cons( "Don't you see any solution to this?",
       l.cons( "Is this your only problem?",
       l.cons( "Has this always been a problem?",
       l.empty()))));

    iWant
     = l.cons( "?Why do you want",
       l.cons( "?What would it mean to you if you got",
       l.cons( "?Suppose you got",
       l.cons( "?What if you never got",
       l.cons( ".I sometimes also want" ,
       l.empty())))));

    question
     = l.cons( "Why do you ask?",
       l.cons( "Does that question interest you?",
       l.cons( "What answer would please you the most?",
       l.cons( "What do you think?",
       l.cons( "Are such questions on your mind often?",
       l.cons( "What is it that you really want to know?",
       l.cons( "Have you asked anyone else?",
       l.cons( "Have you asked such questions before?",
       l.cons( "What else comes to mind when you ask that?" ,
       l.empty())))))))));

    name
     = l.cons( "Names don't interest me.",
       l.cons( "I don't care about names --please go on." ,
       l.empty()));

    because
     =  l.cons( "Is that the real reason?",
        l.cons( "Don't any other reasons come to mind?",
        l.cons( "Does that reason explain anything else?",
        l.cons( "What other reasons might there be?" ,
        l.empty()))));

    sorry	
     = l.cons( "Please don't apologise!",
       l.cons( "Apologies are not necessary.",
       l.cons( "What feelings do you have when you apologise?",
       l.cons( "Don't be so defensive!" ,
       l.empty()))));

    dream
     = l.cons( "What does that dream suggest to you?",
       l.cons( "Do you dream often?",
       l.cons( "What persons appear in your dreams?",
       l.cons( "Are you disturbed by your dreams?" ,
       l.empty()))));

    hello
     = l.cons( "How do you...please state your problem." ,l.empty());

    maybe
     = l.cons( "You don't seem quite certain.",
       l.cons( "Why the uncertain tone?",
       l.cons( "Can't you be more positive?",
       l.cons( "You aren't sure?",
       l.cons( "Don't you know?" ,
       l.empty())))));

    your
     = l.cons( "?Why are you concerned about my",
       l.cons( "?What about your own" ,l.empty()));

    always
     = l.cons( "Can you think of a specific example?",
       l.cons( "When?",
       l.cons( "What are you thinking of?",
       l.cons( "Really, always?" ,l.empty()))));

    think
     = l.cons( "Do you really think so?",
       l.cons( "?But you are not sure you",
       l.cons( "?Do you doubt you" ,l.empty())));

    alike
     = l.cons( "In what way?",
       l.cons( "What resemblence do you see?",
       l.cons( "What does the similarity suggest to you?",
       l.cons( "What other connections do you see?",
       l.cons( "Cound there really be some connection?",
       l.cons( "How?" ,l.empty()))))));

    friend
     = l.cons( "Why do you bring up the topic of friends?",
       l.cons( "Do your friends worry you?",
       l.cons( "Do your friends pick on you?",
       l.cons( "Are you sure you have any friends?",
       l.cons( "Do you impose on your friends?",
       l.cons( "Perhaps your love for friends worries you." ,l.empty()))))));

    respMsgs   
       = l.cons(new Pair(l.words("CAN YOU"),	canYou),
         l.cons(new Pair(l.words("CAN I"),       canI),
         l.cons(new Pair(l.words("YOU ARE"),		youAre),
         l.cons(new Pair(l.words("YOU'RE"),		youAre),
         l.cons(new Pair(l.words("I DON'T"),		iDont),
         l.cons(new Pair(l.words("I DON NOT"),		iDont),
         l.cons(new Pair(l.words("I FEEL"),		iFeel),
         l.cons(new Pair(l.words("WHY DON'T YOU"),	whyDont),
         l.cons(new Pair(l.words("WHY CAN'T I"),	whyCant),
         l.cons(new Pair(l.words("ARE YOU"),		areYou), 
         l.cons(new Pair(l.words("I CAN'T"),		iCant),
         l.cons(new Pair(l.words("I CANNOT"),		iCant),
         l.cons(new Pair(l.words("I AM"),		iAm),
         l.cons(new Pair(l.words("I'M"),		iAm),
         l.cons(new Pair(l.words("YOU"), 		you),
         l.cons(new Pair(l.words("YES"),		yes),
         l.cons(new Pair(l.words("NO"),			no),
         l.cons(new Pair(l.words("I HAVE A PROBLEM"),	problem),
         l.cons(new Pair(l.words("I'VE A PROBLEM"),	problem),
         l.cons(new Pair(l.words("PROBLEM"),    	problem),
         l.cons(new Pair(l.words("COMPUTER"),		computer),
         l.cons(new Pair(l.words("COMPUTERS"),		computer),
         l.cons(new Pair(l.words("I WANT"),		iWant),
         l.cons(new Pair(l.words("WHAT"),		question),
         l.cons(new Pair(l.words("HOW"),		question),
         l.cons(new Pair(l.words("WHO"),		question),
         l.cons(new Pair(l.words("WHERE"),		question),
         l.cons(new Pair(l.words("WHEN"),		question),
         l.cons(new Pair(l.words("WHY"),		question),
         l.cons(new Pair(l.words("NAME"),		name),
         l.cons(new Pair(l.words("BECAUSE"),		because),
         l.cons(new Pair(l.words("CAUSE"),		because),
         l.cons(new Pair(l.words("SORRY"),		sorry),
         l.cons(new Pair(l.words("DREAM"),		dream),
         l.cons(new Pair(l.words("DREAMS"),		dream),
         l.cons(new Pair(l.words("HI"),			hello),
         l.cons(new Pair(l.words("HELLO"),		hello),
         l.cons(new Pair(l.words("MAYBE"),		maybe),
         l.cons(new Pair(l.words("YOUR"),		your),
         l.cons(new Pair(l.words("ALWAYS"),		always),
         l.cons(new Pair(l.words("THINK"),		think),
         l.cons(new Pair(l.words("ALIKE"),		alike),
         l.cons(new Pair(l.words("FRIEND"),		friend),
         l.cons(new Pair(l.words("FRIENDS"),		friend),
       	 l.cons(new Pair(l.empty(),			nokeyMsgs), 
         l.empty())))))))))))))))))))))))))))))))))))))))))))));
    }
}
