package de.tfhberlin.panitz.eliza;
/**
  A simulation of a psycho therapist. 
  This program has been converted from Mark .P. Jones
  Gofer implementation.
**/
public class Eliza implements ButtonLogic  {

  Li l;
  Data data;
  String prev = "";

  public Eliza(Li l){this.l=l;data=new Data(l);}
 
  public String getDescription(){
    return "submit";
  }

  public String eval(String s){
    String result = "";	

    if (s.equals(prev)) {
      result = (String)data.repeatMsgs.head();
      data.repeatMsgs.rotate();
    }else {
       Li/*String*/ question  = l.words(stripPunctuation(s));
       result = answer(question);
    }
    prev = s;
    return result;
  }

  static public String stripPunctuation(String s){
      String result="";
      for (int i=0;i<s.length();i=i+1){
	  if (PUNCTUATIONS.indexOf(s.charAt(i))<0){
	      result=result+s.charAt(i);
	  }
      }
      return result;
  }

  static final String PUNCTUATIONS =".,;:?!";

  String answer (Li/*String*/ question){
    return ans(data.respMsgs,question);
  }

  
  String ans(Li es, Li l){
    Pair e = (Pair)es.head();
    Li key = (Li)e.fst;
    Li as = (Li)e.snd;

    Li rs = replies(key,l)  ;
    if (rs.isEmpty()) return ans(es.tail(),l);
    else {
      as.rotate();
      return makeResponse((String)as.head(),(String)rs.head());
    }
  }

  public Li/*String*/ replies(Li/*String*/  key, Li/*String*/ question){ 
    Li result = l.empty();
    int keyLength = key.length();

    Li questionFragments = question.tails();
    Li matchingFragments
      = questionFragments.filter(new IsPrefixIgnoreCaseFilter(key));

    for (Li xs=matchingFragments;!xs.isEmpty();xs=xs.tail()){
	result = l.cons( 
          conjug(question, ((Li)xs.head() ).drop(keyLength)),result); 
    }
    return result;
  }

  String conjug(Li q, Li xs){
    Li sel = xs.isEmpty()?q:xs;
    Li result = l.empty();
    for (Li ys= sel;!ys.isEmpty();ys= ys.tail()){
      result = l.cons(conj(data.CONJUGATES,ys.head()),result);
    }
    return result.reverse().unwords();
  }

  Object conj(Li cs,Object s){
    if (cs.isEmpty()) return s;
    Pair p = (Pair)cs.head();
    if (p.fst.equals(s)) return p.snd;
    return conj(cs.tail(),s);
  }

  String makeResponse(String cs,String us){
    if (cs.charAt(0)=='?') return cs.substring(1)+us+"?";
    if (cs.charAt(0)=='.') return cs.substring(1)+us+".";
    return cs;
  }
}
